function Declare_Players()

Player = {
  
  X = 19,
  Y = 16,
  
  DrawX = 0,
  DrawY = 0,
    
  Frame = PlayerSprites[1],
  
  Name = "Nathan Minkren",
  Active_Ability = 0,
  Direction = "up",
}

PlayerTwo = {
  
  X = 18,
  Y = 16,
  
  DrawX = 0,
  DrawY = 0,
  
  Frame = PlayerSprites[2],
  
  Name = "Sanne Lund",  
  Active_Ability = 0,  
  Direction = "up",
}

turndef = {Player, PlayerTwo} --1:Player, 2:PlayerTwo

end

function Player_ConstantUpdate(player)
    
  --where to draw
  player.DrawX = Field_OffsetX + (player.X-1)*TileSize
  player.DrawY = Field_OffsetY + (player.Y-1)*TileSize
  
  --count mouse-player-horizon angle
  local angle = math.atan2(player.DrawX-love.mouse.getX(), player.DrawY-love.mouse.getY() )
  
	--change player sprite
	if      180-math.deg(angle) > 315 or  180-math.deg(angle) < 45  then player.Direction = "down" 
	elseif  180-math.deg(angle) < 315 and 180-math.deg(angle) > 225 then player.Direction = "right"
	elseif  180-math.deg(angle) < 225 and 180-math.deg(angle) > 135 then player.Direction = "up"
	elseif  180-math.deg(angle) < 135 and 180-math.deg(angle) > 45  then player.Direction = "left"
	end  
    
end

function Player_Control(character, key)
    
    --every actions that are considered one step
    if key == "w" and character.Y > 1 and not Collision_Basic(character.X, character.Y, "up") then 
      if steps_left > 0 then 
      character.Y = character.Y - 1
      character.Direction = "up"
      steps_left=steps_left-1 
      else EndTurn() end
    end   
    
    if key == "s" and character.Y < SizeY and not Collision_Basic(character.X, character.Y, "down") then 
      if steps_left > 0 then 
      character.Y = character.Y + 1 
      character.Direction = "down"
      steps_left=steps_left-1 
      else EndTurn() end
    end  
    
    if key == "a" and character.X > 1 and not Collision_Basic(character.X, character.Y, "left") then 
      if steps_left > 0 then 
      character.X = character.X - 1 
      character.Direction = "left"
      steps_left=steps_left-1 
      else EndTurn() end 
    end 
    
    if key == "d" and character.X < SizeX and not Collision_Basic(character.X, character.Y, "right") then 
      if steps_left > 0 then 
      character.X = character.X + 1 
      character.Direction = "right"
      steps_left=steps_left-1 
      else EndTurn() end 
    end 
    
    --makes turns more dynamic
    --if key ~= nil and steps_left == 0 then EndTurn() end 

end



--based on ABILITYSET.PNG
function Player_CastAbility(player,id)
  
  local set = {}
  local entireset = {}
  local tempset = {}
  local abilitymap = love.image.newImageData('ABILITYSET.png')
  
  --loading and processing abilityset.png  
  local ImgX, ImgY = abilitymap:getDimensions( )
  local abmapX, abmapY = 9, 11
  local abstart = (id-1)*abmapX
  
  local which = 0
  
  if player == Player then which = 0 else which = abmapY end
  
  --direction-neutral abilities
  if player.Direction == "left" or player.Direction == "up" then
    
    for i=abstart, abstart+abmapX-1 do
      for j=which, which+abmapY-1 do
        
        local r,g,b,a = abilitymap:getPixel(i,j)
        
        if g == 255 then   
          
          if player.Direction == "left" then
            table.insert(set, {j + player.X - 6 - which, i + player.Y - 4 - abstart} )
          elseif player.Direction == "up" then          
            table.insert(set, {i + player.X - 4 - abstart, j + player.Y - 6 - which} )
          end
        end
        
      end
    end
    
  elseif player.Direction == "right" or player.Direction == "down" then
  
    for i=abstart+abmapX-1, abstart, -1 do
      for j=which+abmapY-1, which, -1 do
        
        local r,g,b,a = abilitymap:getPixel(i,j)
        
        if g == 255 then   
          
          if player.Direction == "right" then
            table.insert(set, {-j + player.X + 6 + which, i + player.Y - 4 - abstart} )
          elseif player.Direction == "down" then          
            table.insert(set, {i + player.X - 4 - abstart, -j + player.Y + 6 + which} )
          end
        end
        
      end
    end  
  
  end



  return set
  
end