function love.keypressed( key )
  
  if key == "q" then EndTurn() end
  
  --in player.lua
  Player_Control(turndef[turn], key)
  
end

--regular mouse buttons
function love.mousepressed( x, y, button, istouch )  
  
  --if button == "1" then
      
      --click on playfield
      if  love.mouse.getX() < Field_DrawX
      and love.mouse.getY() < Field_DrawY then
        
        --if there are more steps left than the cost of the current ability
        if turndef[turn].Active_Ability ~= 0
        and (steps_left >= ability_costs[turndef[turn].Active_Ability]) then
          
          --then execute it
          local tiles = Player_CastAbility(turndef[turn],turndef[turn].Active_Ability)
          
          for i=1, #tiles do 
            
            if  tiles[i][1] > 0 and tiles[i][1] <= SizeX
            and tiles[i][2] > 0 and tiles[i][2] <= SizeY 
            and not Collision_Basic(tiles[i][1],tiles[i][2], "self")  --collision
            and Abst[tiles[i][1]][tiles[i][2]] ~= 6                --shadow tower
            then
            
              Field[tiles[i][1]][tiles[i][2]] = 3 
            
            end
            
          end
          
          --then "pay the costs" and turn off selector
          steps_left = steps_left - ability_costs[turndef[turn].Active_Ability]   
          turndef[turn].Active_Ability = 0

        end
      

      end
      
  --end  

end

--mousewheel
function love.wheelmoved( x, y )
  
  --mouse wheel up
  if y > 0 then

        if turndef[turn].Active_Ability < 10 then
          turndef[turn].Active_Ability = turndef[turn].Active_Ability+1
        end
  end
  
  --mouse wheel down
  if y < 0 then 
    
        if turndef[turn].Active_Ability > 0 then
          turndef[turn].Active_Ability = turndef[turn].Active_Ability-1
        end
  end  


end

--constant actions
function MouseActions()
  
    if love.mouse.isDown(1) then
      
      --click on HUD
      for i=1, 6 do
        --zoom & move away
        --local centertile = 
        
        if      Navbar[1].Selected and Zoom >= 0 then 
          Zoom = Zoom - 0.004
          Field_OffsetX = Field_OffsetX + 2    
          Field_OffsetY = Field_OffsetY + 2       
        elseif  Navbar[3].Selected then 
          Zoom = Zoom + 0.004
          Field_OffsetX = Field_OffsetX - 2   
          Field_OffsetY = Field_OffsetY - 2  
            
        elseif  Navbar[2].Selected then Field_OffsetY = Field_OffsetY + 2 
        elseif  Navbar[4].Selected then Field_OffsetX = Field_OffsetX + 2  
        elseif  Navbar[5].Selected then Field_OffsetY = Field_OffsetY - 2 
        elseif  Navbar[6].Selected then Field_OffsetX = Field_OffsetX - 2         
        end
      
      end
      
    end
  
end

